-- client.lua

local function getVehicleInDirection(from, to)
    local rayHandle = StartShapeTestRay(from.x, from.y, from.z, to.x, to.y, to.z, 10, PlayerPedId(), 0)
    local _, hit, _, _, vehicle = GetShapeTestResult(rayHandle)
    return hit and vehicle or nil
end

local function getClosestFourDoorVehicle(radius)
    local playerPed = PlayerPedId()
    local playerPos = GetEntityCoords(playerPed)
    local closestVehicle = nil
    local vehicles = GetGamePool('CVehicle')
    
    for _, vehicle in ipairs(vehicles) do
        local vehiclePos = GetEntityCoords(vehicle)
        local distance = #(vehiclePos - playerPos)
        if distance < radius and GetVehicleModelNumberOfSeats(GetEntityModel(vehicle)) == 4 then
            radius = distance
            closestVehicle = vehicle
        end
    end
    
    return closestVehicle
end

local function enterBackSeat()
    local playerPed = PlayerPedId()
    local playerPos = GetEntityCoords(playerPed)
    local inVehicle = IsPedInAnyVehicle(playerPed, false)
    
    if not inVehicle then
        local vehicle = getClosestFourDoorVehicle(5.0)
        
        if vehicle then
            if IsVehicleSeatFree(vehicle, 1) then
                TaskEnterVehicle(playerPed, vehicle, 10000, 1, 2.0, 1, 0)
            elseif IsVehicleSeatFree(vehicle, 2) then
                TaskEnterVehicle(playerPed, vehicle, 10000, 2, 2.0, 1, 0)
            else
                print("No back seat available.")
            end
        else
            print("No four-door vehicle found nearby.")
        end
    else
        print("You are already in a vehicle.")
    end
end

Citizen.CreateThread(function()
    while true do
        Citizen.Wait(0)
        if IsControlJustReleased(0, Config.BackSeatKey) then
            enterBackSeat()
        end
    end
end)
